﻿<?xml version="1.0" encoding="utf-8" ?>
<nlog xmlns="http://www.nlog-project.org/schemas/NLog.xsd"
      xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
      throwConfigExceptions="true"
      throwExceptions="false"
	  internalLogFile="Logs/internal-nlog.txt"
	  internalLogLevel="Trace">

	<extensions>
		<add assembly="Coscine.SemanticSearch" />
	</extensions>
	
	<targets>
		<!-- Write logs to File -->
		<target xsi:type="FallbackGroup" 
			name="fileGroup">
			<target 
				xsi:type="File" 
				name="fileLogD" 
				fileName="D:/coscine/logs/${assembly-name}/${assembly-version}/log-${shortdate}.log"
				maxArchiveFiles="7"
			>
				<layout xsi:type="CompoundLayout">
					<layout xsi:type="JsonLayout" EscapeForwardSlash="true">
						<attribute layout="${longdate}" name="Timestamp"/>
						<attribute layout="${level:upperCase=true}" name="Level"/>
						<attribute layout="${message}" name="Message"/>
						<attribute layout="${exception:format=tostring,StackTrace}" name="Exception"/>
						<attribute layout="${ndlc}" name="Context"/>
						<attribute layout="${event-properties:item=Metric}" name="Alarm" encode="false"/>
						<attribute name="EventProperties" encode="false" >
							<layout xsi:type='JsonLayout' includeAllProperties="true"  maxRecursionLimit="2"/>
						</attribute>
					</layout>
					<layout xsi:type='SimpleLayout' text="," />
				</layout>
			</target>
			<target 
				xsi:type="File" 
				name="fileLogC" 
				fileName="C:/coscine/logs/${assembly-name}/${assembly-version}/log-${shortdate}.log"
				maxArchiveFiles="7"
			>
				<layout xsi:type="CompoundLayout">
					<layout xsi:type="JsonLayout" EscapeForwardSlash="true">
						<attribute layout="${longdate}" name="Timestamp"/>
						<attribute layout="${level:upperCase=true}" name="Level"/>
						<attribute layout="${message}" name="Message"/>
						<attribute layout="${exception:format=tostring,StackTrace}" name="Exception"/>
						<attribute layout="${ndlc}" name="Context"/>
						<attribute layout="${event-properties:item=Metric}" name="Alarm" encode="false"/>
						<attribute name="EventProperties" encode="false" >
							<layout xsi:type='JsonLayout' includeAllProperties="true"  maxRecursionLimit="2"/>
						</attribute>
					</layout>
					<layout xsi:type='SimpleLayout' text="," />
				</layout>
			</target>
		</target>

		<!-- Write colored logs to Console -->
		<target name="consoleLog" xsi:type="ColoredConsole" layout="[${uppercase:${level}}]: ${message}">
			<highlight-row condition="level == LogLevel.Debug" foregroundColor="DarkGray" />
			<highlight-row condition="level == LogLevel.Info" foregroundColor="White" />
			<highlight-row condition="level == LogLevel.Warn" foregroundColor="Yellow" />
			<highlight-row condition="level == LogLevel.Error" foregroundColor="DarkRed" />
			<highlight-row condition="level == LogLevel.Fatal" foregroundColor="Red" backgroundColor="White" />
		</target>
	</targets>


	<rules>
		<!--All logs, including from Microsoft, Level Trace-->
		<logger name="*" minlevel="Trace" writeTo="fileGroup">
		</logger>

		<!--All logs, including from Microsoft, Level Info-->
		<logger name="*" minlevel="Info" writeTo="consoleLog">
			<filters defaultAction="Log">
				<when condition="contains('${ndlc}','/api/heartbeat')" action="Ignore"/>
			</filters>
		</logger>

	</rules>
</nlog>